local _G = getfenv(0);
local AceOO = AceLibrary("AceOO-2.0");
local BS = AceLibrary("Babble-Spell-2.2");


function Klappa:CreateBar()
	Klappa.header = {};
	self:CreateRoot();
	self:CreateHeader(1);
	for i = 1,4 do
		self:CreateButton(10+i, Klappa.header[1]);
	end
	self:CreateHeader(2);
	for i = 1,4 do
		self:CreateButton(20+i, Klappa.header[2]);
	end
	self:CreateHeader(3);
	for i = 1,4 do
		self:CreateButton(30+i, Klappa.header[3]);
	end
end



function Klappa:CreateHeader(ID)
	Klappa.header[ID] = CreateFrame("Button", "KlappaButton"..ID, Klappa.root, "ActionButtonTemplate,SecureActionButtonTemplate,SecureAnchorEnterTemplate");
	Klappa.header[ID]:SetWidth(34);
	Klappa.header[ID]:SetHeight(34);
	Klappa.header[ID]:SetPoint("TOPLEFT", Klappa.root, "TOPLEFT", -34, -37*ID);
	
	Klappa.header[ID].texture = Klappa.header[ID]:CreateTexture(nil, "OVERLAY");
	Klappa.header[ID].texture:SetAllPoints(Klappa.header[ID]);
	Klappa.header[ID].texture:SetTexture(GetSpellTexture(""));
	Klappa.header[ID].texture:Show();
	
	Klappa.header[ID]:RegisterForClicks("LeftButtonUp","RightButtonUp");
	Klappa.header[ID]:RegisterForDrag("LeftButton");
	Klappa.root:SetAttribute("AddChild", Klappa.header[ID]);
	
	Klappa.header[ID]:SetAttribute("showstates", "*");
	Klappa.header[ID]:SetAttribute("delaystate", "0");
	Klappa.header[ID]:SetAttribute("delaytime", "0.5");
	Klappa.header[ID]:SetAttribute("delayhover", "any");
	Klappa.header[ID]:SetAttribute("newstate", tostring(ID));
	Klappa.header[ID]:SetAttribute("*childstate-OnEnter", "enter"..ID);
	Klappa.header[ID]:SetAttribute("*childstate-OnLeave", "leave"..ID);
	Klappa.header[ID]:SetAttribute("anchorchild", Klappa.root);
	Klappa.header[ID]:SetAttribute("childstate", "^" .. tostring(ID));
	--Klappa.header:SetScript("PostClick",function() self:TriggerEvent("Yata_ButtonClick",ID); end);
	Klappa.header[ID]:SetScript("OnDragStart", function() Klappa:ButtonDrag(ID); end);
	Klappa.header[ID]:SetScript("OnReceiveDrag", function() Klappa:ButtonDrop(ID); end);
	
	--Klappa.header[ID]:SetAttribute("*type*", "spell");
	--Klappa.header[ID]:SetAttribute("*type*", "item");
	Klappa.header[ID].Spell = ""

	Klappa.header[ID]:Show();	
	if(self.db.profile[ID] ~="" and self.db.profile[ID] ~= nil) then
		if(self.db.profile[ID].Type == "spell") then
			local spellName = self.db.profile[ID].Name;
			Klappa.header[ID]:SetAttribute("*type*", "spell");
			Klappa.header[ID]:SetAttribute("spell1", spellName);
			Klappa.header[ID].Spell = spellName;
			Klappa.header[ID].texture:SetTexture(GetSpellTexture(spellName));
		elseif (self.db.profile[ID].Type == "item") then
			local itemName = self.db.profile[ID].Name;
			Klappa.header[ID]:SetAttribute("*type*", "item");
			Klappa.header[ID]:SetAttribute("item1", itemName);
			Klappa.header[ID].Spell = itemName;
			local a, b, c, d, e, f, g, h, i, itemTexture = GetItemInfo(itemName);
			Klappa.header[ID].texture:SetTexture(itemTexture);
		elseif (self.db.profile[ID].Type == "macro") then
			local index =  self.db.profile[ID].Name;
			Klappa.header[ID]:SetAttribute("*type*", "macro");
			Klappa.header[ID]:SetAttribute("macro1", index);
			Klappa.header[ID].Spell = index;
			local macroName, texture, macrobody, localVar = GetMacroInfo(index)
			Klappa.button.texture:SetTexture(texture);
		end
	end
	
end

function Klappa:OnHover()

end
function Klappa:CreateButton(ID, header)
	Klappa.button = CreateFrame("Button", "KlappaButton"..ID, Klappa.root, "SecureActionButtonTemplate,ActionButtonTemplate");
	--Klappa.button:SetWidth(32);
	--Klappa.button:SetHeight(32);
	Klappa.button:SetPoint("TOPLEFT", header, "TOPLEFT", -36*(ID%10), 0);
	Klappa.button.texture = Klappa.button:CreateTexture(nil, "OVERLAY");
	Klappa.button.texture:SetAllPoints(Klappa.button);
	Klappa.button.texture:SetTexture(GetSpellTexture(""));
	Klappa.button.texture:Show();
	
	Klappa.button:RegisterForDrag( "LeftButton" );
	Klappa.button:RegisterForClicks("LeftButtonUp","RightButtonUp");
	Klappa.button:SetAttribute("showstates", math.floor(ID/10));
	Klappa.button:SetAttribute("newstate", "0");
	--Klappa.button:SetAttribute("*type*", "spell");
	--Klappa.button:SetAttribute("*type*", "item");
	Klappa.button.Spell = "";
	Klappa.button:SetScript("OnDragStart", function() Klappa:ButtonDrag(ID); end);
	Klappa.button:SetScript("OnReceiveDrag", function() Klappa:ButtonDrop(ID); end);
	Klappa.root:SetAttribute("AddChild",Klappa.button);
	if(self.db.profile[ID] ~="" and self.db.profile[ID] ~= nil) then
		if(self.db.profile[ID].Type == "spell") then
			spellName = self.db.profile[ID].Name;
			Klappa.button:SetAttribute("*type*", "spell");
			Klappa.button:SetAttribute("spell1", spellName);
			--Klappa:Print(ID);
			--Klappa:Print(spellName);
			Klappa.button.Spell = spellName;
			Klappa.button.texture:SetTexture(GetSpellTexture(spellName));
		elseif (self.db.profile[ID].Type == "item") then
			local itemName = self.db.profile[ID].Name;
			Klappa.button:SetAttribute("*type*", "item");
			Klappa.button:SetAttribute("item1", itemName);
			Klappa.button.Spell = itemName;
			local a, b, c, d, e, f, g, h, i, itemTexture = GetItemInfo(itemName);
			Klappa.button.texture:SetTexture(itemTexture);
		elseif (self.db.profile[ID].Type == "macro") then
			local index =  self.db.profile[ID].Name;
			Klappa.button:SetAttribute("*type*", "macro");
			Klappa.button:SetAttribute("macro1", index);
			Klappa.button.Spell = index;
			local macroName, texture, macrobody, localVar = GetMacroInfo(index)
			Klappa.button.texture:SetTexture(texture);
		end
		
	end	
end

function Klappa:ButtonDrag(ID)
	local button = _G["KlappaButton"..ID];
	if(button.Spell ~= "") then
		PickupSpell(button.Spell);
		button:SetAttribute("spell1", "");
		button.Spell = ""
		button.texture:SetTexture("");
	end
end


function Klappa:ButtonDrop(ID)
	local button = _G["KlappaButton"..ID];
	if(CursorHasSpell()) then
		spell, slot = GetCursorInfo()
		if(spell ~= nil) then
			--Klappa:Print("Info");
			--Klappa:Print(spell);
			--Klappa:Print(slot);
			--Klappa:Print("Spellname");
			--Klappa:Print(GetSpellName(slot, BOOKTYPE_SPELL));
			spellName, spellRank = GetSpellName(slot, BOOKTYPE_SPELL)
			button:SetAttribute("*type*", "spell");
			button:SetAttribute("spell1", spellName.."("..spellRank..")");
			button.Spell = spellName.."("..spellRank..")";
			button.texture:SetTexture(GetSpellTexture(slot,BOOKTYPE_SPELL));
			self.db.profile[ID] = {};
			self.db.profile[ID].Name = spellName.."("..spellRank..")";
			self.db.profile[ID].Type = "spell";
			button.Type = "spell";
		else
			self.db.profile[ID] = "";
			button.Type = "";
		end
	elseif(CursorHasItem()) then
		--Klappa:Print("item");
		local itemID, link = GetCursorInfo();
		local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount, itemEquipLoc, itemTexture = GetItemInfo(link);
		--Klappa:Print(itemID.."::"..link.."::"..sName.."::");
		--Klappa:Print(sLink);
		--Klappa:Print(itemTexture);
		button:SetAttribute("*type*", "item");
		button:SetAttribute("item1", sName);
		button.texture:SetTexture(itemTexture);
		button.Spell = sName;
		self.db.profile[ID] = {};
		self.db.profile[ID].Name = sName;
		self.db.profile[ID].Type = "item";
		button.Type = "item";
	elseif(CursorHasMacro()) then
		local macro, index  = GetCursorInfo();
		local macroName, texture, macrobody, localVar = GetMacroInfo(index)
		Klappa:Print(macroName);
		Klappa:Print(texture);
		button:SetAttribute("*type*", "macro");
		button:SetAttribute("macro1", index);
		button.texture:SetTexture(texture);
		button.Spell = index;
		button:SetText(macroName);
		self.db.profile[ID] = {};
		self.db.profile[ID].Name = index;
		self.db.profile[ID].Type = "macro";
		button.Type = "macro";
	else
		--Klappa:Print("nichts");
		self.db.profile[ID] = "";
		button.Type = "";
	end
	
	ClearCursor();
	
end

function Klappa:CreateRoot()
	Klappa.root = CreateFrame("Frame", "KlappaRoot", UIParent, "SecureStateHeaderTemplate");
	Klappa.root:SetPoint("CENTER", UIParent, "CENTER", 500, -20);
	Klappa.root:SetWidth(20);
	Klappa.root:SetHeight(32);
	Klappa.root.texture = Klappa.root:CreateTexture();
	Klappa.root.texture:SetTexture(0,0,0.5,1);
	Klappa.root.texture:SetAllPoints(Klappa.root);
	--Klappa.root.texture:Hide();

	for i = 1, 4 do
		Klappa.root:SetAttribute("statemap-anchor-enter"..i, "*:"..i);
		Klappa.root:SetAttribute("statemap-anchor-leave"..i,      ";");
		Klappa.root:SetAttribute("delaystatemap-anchor-leave"..i, i..":0");
		Klappa.root:SetAttribute("delaytimemap-anchor-leave"..i,  i..":0.5");
		Klappa.root:SetAttribute("delayhovermap-anchor-leave"..i, i..":true");
	end
	Klappa.root:EnableMouse(true);
	Klappa.root:SetMovable(true);
	Klappa.root:RegisterForDrag("LeftButton");
	
	Klappa.root:Show();
	Klappa.root:SetScript("OnDragStart", function() Klappa:RootDrag(); end);
	Klappa.root:SetScript("OnDragStop", function() Klappa:RootDragStop(); end);
	
	if(self.db.profile.Position) then
		x = self.db.profile.Position.x;
		y = self.db.profile.Position.y;
		scale = Klappa.root:GetEffectiveScale();
	else
		Klappa.root:ClearAllPoints();
		Klappa.root:SetPoint( "CENTER", WorldFrame, "CENTER", 0,0 );
		scale = Klappa.root:GetEffectiveScale();
		x = Klappa.root:GetLeft()*scale;
		y = Klappa.root:GetBottom()*scale;
	end
	Klappa.root:ClearAllPoints();
	Klappa.root:SetPoint("BOTTOMLEFT", UIParent,"BOTTOMLEFT", x/scale, y/scale);
	Klappa.root:SetScale(self.db.profile.ButtonScale);
	if(Klappa.locked) then
		Klappa.root.texture:Hide();
	end
end

function Klappa:RootDrag()
	--Klappa:Print("DragSTart");
	Klappa.root:StartMoving()
	Klappa.root.isMoving = true;
end

function Klappa:RootDragStop()
--Klappa:Print("DragStop");
	Klappa.root:StopMovingOrSizing();
	Klappa.root.isMoving = false;
	Klappa:SaveRootPos();
end

function Klappa:SaveRootPos()
	if not self.db.profile.Position then 
		self.db.profile.Position = {};
	end
	local scale = Klappa.root:GetEffectiveScale();
	scale = scale / self.db.profile.ButtonScale;
	local x = Klappa.root:GetLeft()*scale;
	local y = Klappa.root:GetBottom()*scale; 
	self.db.profile.Position.x = x;
	self.db.profile.Position.y = y;
end
